include 'Zeropage.inc'
include 'Vram.inc'

pSource equ ZW0
pDestination equ ZW1
sourceOffset equ ZB0
destinationOffset equ ZB1
sourceByte equ ZB2
xCount equ ZB3

cseg
Multi8:
    sta <0,x
    lda #0 | sta <1,x
    asl <0,x | rol <1,x ;*2
    asl <0,x | rol <1,x ;*4
    asl <0,x | rol <1,x ;*8
rts

cseg
SetPatternMono:
    do
        ldy #0 | sty <sourceOffset | sty <destinationOffset
        do
            lda (<pSource),y | sta <sourceByte
            lda #2 | sta <xCount
            do
                ldy <destinationOffset
                lda #0 | sta (<pDestination),y
                ldx #4
                do
                    lda (<pDestination),y
                    asl a
                    asl a
                    sta (<pDestination),y

                    lda <sourceByte
                    and #$80
                    if ne
                        lda SetPatternMono_@Param2
                    else
                        lda #0
                    endif
                    ora (<pDestination),y
                    sta (<pDestination),y

                    asl <sourceByte
                    dex
                while ne | wend       
                iny
                sty <destinationOffset
                dec <xCount
            while ne | wend

            ldy <sourceOffset
            iny
            sty <sourceOffset
            cpy #4
        while ne | wend
        lda <pSource | clc|adc #4 | sta <pSource
        lda <pSource+1 | adc #0 | sta <pSource+1

        lda <pDestination | clc|adc #8 | sta <pDestination
        lda <pDestination+1 | adc #0 | sta <pDestination+1

        dec SetPatternMono_@Param3
    while ne | wend
rts

; void SetPatternMono(ptr<byte> pSource, byte pattern, byte color, byte count);
dseg
SetPatternMono_@Param0: public SetPatternMono_@Param0
    defw 0
SetPatternMono_@Param1: public SetPatternMono_@Param1
    defb 0
SetPatternMono_@Param2: public SetPatternMono_@Param2
    defb 0
SetPatternMono_@Param3: public SetPatternMono_@Param3
    defb 0
cseg
SetPatternMono_: public SetPatternMono_
    pha
        lda SetPatternMono_@Param0 | sta <pSource
        lda SetPatternMono_@Param0+1 | sta <pSource+1

        lda SetPatternMono_@Param1
        ldx #pDestination | jsr Multi8
        lda <pDestination | clc|adc #low CharRam | sta <pDestination
        lda <pDestination+1 | adc #high CharRam | sta <pDestination+1

        jsr SetPatternMono
    pla
rts


; void SetPatternColor(ptr<byte> pSource, byte pattern, byte count);
dseg
SetPatternColor_@Param0: public SetPatternColor_@Param0
    defw 0
SetPatternColor_@Param1: public SetPatternColor_@Param1
    defb 0
SetPatternColor_@Param2: public SetPatternColor_@Param2
    defb 0
cseg
SetPatternColor_: public SetPatternColor_
    pha
        lda SetPatternColor_@Param0 | sta <pSource
        lda SetPatternColor_@Param0+1 | sta <pSource+1

        lda SetPatternColor_@Param1
        ldx #pDestination | jsr Multi8
        lda <pDestination | clc|adc #low CharRam | sta <pDestination
        lda <pDestination+1 | adc #high CharRam | sta <pDestination+1
        do

            ldy #0
            do
                lda (<pSource),y
                sta (<pDestination),y
                iny
                cpy #8
            while ne | wend
            lda <pSource | clc|adc #8 | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1

            lda <pDestination | clc|adc #8 | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1

            dec SetPatternColor_@Param2
        while ne | wend
    pla
rts


ext ManPattern_
dseg
ManPattern: public ManPattern
    defs CharHeight*4*18

; void InitManPattern();
cseg
InitManPattern_: public InitManPattern_
    pha
        lda #low ManPattern_ | sta <pSource
        lda #high ManPattern_ | sta <pSource+1

        lda #low ManPattern | sta <pDestination
        lda #high ManPattern | sta <pDestination+1

        lda #3 | sta SetPatternMono_@Param2
        lda #4*18 | sta SetPatternMono_@Param3

        jsr SetPatternMono
    pla
rts


; void UpdateManPattern();
ext ManPatternCode_
Char_Man equ $47
ManPatternDestination equ CharRam+CharHeight*Char_Man
cseg
UpdateManPattern_: public UpdateManPattern_
    pha
        lda ManPatternCode_
        ldx #pSource | jsr Multi8

        lda <pSource | clc|adc #low ManPattern | sta <pSource
        lda <pSource+1 | adc #high ManPattern | sta <pSource+1

        lda #low ManPatternDestination | sta <pDestination
        lda #high ManPatternDestination | sta <pDestination+1
        ldy #0
        do
            lda (<pSource),y | sta (<pDestination),y
            iny
            cpy #CharHeight*4
        while ne | wend
    pla
rts
